package net.astah.stpa.stamp.constraints;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.validation.model.IClientSelector;

import net.astah.stpa.stamp.STAMPPackage;

/**
 * STAMP/STPA メタモデルのインスタンスをモデル検証の対象として選択します。
 */
public class STAMPModelSelector implements IClientSelector {

    /**
     * 指定されたモデルがクライアントコンテキストの対象であるか判定します。
     * 
     * @param object
     *            判定するオブジェクト
     * @return 対象とする場合は <code>true</code> 、それ以外は <code>false</code>
     */
    @Override
    public boolean selects(final Object object) {
        if (object instanceof EObject) {
            final EPackage ePackage = ((EObject) object).eClass().getEPackage();
            return ePackage == STAMPPackage.eINSTANCE;
        }
        return false;
    }

}
