/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.project.Facets;
import net.astah.stpa.stamp.Accident;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STAMPPlugin;
import net.astah.stpa.stamp.edit.Messages;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.Accident} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AccidentItemProvider extends IdentifiedElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AccidentItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addHazardPropertyDescriptor(object);
            addIsAnalysisTargetPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Hazard feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addHazardPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Accident_hazard_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Accident_hazard_feature", "_UI_Accident_type"),
                 STAMPPackage.Literals.ACCIDENT__HAZARD,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Is Analysis Target feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addIsAnalysisTargetPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Accident_isAnalysisTarget_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Accident_isAnalysisTarget_feature", "_UI_Accident_type"),
                 STAMPPackage.Literals.ACCIDENT__IS_ANALYSIS_TARGET,
                 true,
                 false,
                 false,
                 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This returns Accident.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/Accident"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((Accident)object).getId();
        return label == null || label.length() == 0 ?
            getString("_UI_Accident_type") :
            getString("_UI_Accident_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(Accident.class)) {
            case STAMPPackage.ACCIDENT__IS_ANALYSIS_TARGET:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @generated NOT
     */
    @Override
    public Object generateInitialValue(Object owner, Object feature) {
        if (feature == STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID) {
            String prefix = "A-";
            return Facets.generateName((EObject) owner, STAMPPlugin.FACET_SYMBOLIC_NAME, prefix,
                    STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID);
        } else if (feature == STAMPPackage.Literals.IDENTIFIED_ELEMENT__DESCRIPTION) {
            return Messages.AccidentItemProvider_default_description_label;
        }
        return super.generateInitialValue(owner, feature);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(EditingDomain domain,
            Object object,
            Collection<Object> collection) {
        Accident owner = (Accident) object;
        collection.addAll(owner.getHazards());
    }

}

