/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.emf.edit.command.InitializeFeatureCommand;
import net.astah.stpa.stamp.ControlStructure;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.ControlStructure} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ControlStructureItemProvider extends NamedElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ControlStructureItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addOwnerPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Owner feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addOwnerPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_ControlStructure_owner_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_ControlStructure_owner_feature", "_UI_ControlStructure_type"),
                 STAMPPackage.Literals.CONTROL_STRUCTURE__OWNER,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPPackage.Literals.CONTROL_STRUCTURE__COMPONENT);
            childrenFeatures.add(STAMPPackage.Literals.CONTROL_STRUCTURE__LINK);
            childrenFeatures.add(STAMPPackage.Literals.CONTROL_STRUCTURE__LINK_END);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns ControlStructure.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/ControlStructure"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((ControlStructure)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_ControlStructure_type") :
            getString("_UI_ControlStructure_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(ControlStructure.class)) {
            case STAMPPackage.CONTROL_STRUCTURE__COMPONENT:
            case STAMPPackage.CONTROL_STRUCTURE__LINK:
            case STAMPPackage.CONTROL_STRUCTURE__LINK_END:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.CONTROL_STRUCTURE__COMPONENT,
                 STAMPFactory.eINSTANCE.createComponent()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.CONTROL_STRUCTURE__LINK,
                 STAMPFactory.eINSTANCE.createControlLink()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.CONTROL_STRUCTURE__LINK,
                 STAMPFactory.eINSTANCE.createFeedbackLink()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.CONTROL_STRUCTURE__LINK_END,
                 STAMPFactory.eINSTANCE.createLinkEnd()));
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createCreateChildCommand(EditingDomain domain,
            EObject owner,
            EStructuralFeature feature,
            Object value,
            int index,
            Collection<?> collection) {
        Command command =
                super.createCreateChildCommand(domain, owner, feature, value, index, collection);
        switch (feature.getFeatureID()) {
        case STAMPPackage.CONTROL_STRUCTURE__COMPONENT:
            command = command.chain(InitializeFeatureCommand.create(domain, value,
                    STAMPPackage.Literals.NAMED_ELEMENT__NAME));
            break;
        }
        return command;
    }

}
