/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.emf.common.notify.EFeaturePath;
import net.astah.project.Facets;
import net.astah.stpa.stamp.HazardCausalFactor;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STAMPPlugin;
import net.astah.stpa.stamp.edit.Messages;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.HazardCausalFactor} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class HazardCausalFactorItemProvider extends IdentifiedElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HazardCausalFactorItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addUnsafeControlActionPropertyDescriptor(object);
            addCountermeasurePropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Unsafe Control Action feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addUnsafeControlActionPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HazardCausalFactor_unsafeControlAction_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HazardCausalFactor_unsafeControlAction_feature", "_UI_HazardCausalFactor_type"),
                 STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Countermeasure feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addCountermeasurePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HazardCausalFactor_countermeasure_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HazardCausalFactor_countermeasure_feature", "_UI_HazardCausalFactor_type"),
                 STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns HazardCausalFactor.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/HazardCausalFactor"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((HazardCausalFactor)object).getId();
        return label == null || label.length() == 0 ?
            getString("_UI_HazardCausalFactor_type") :
            getString("_UI_HazardCausalFactor_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(HazardCausalFactor.class)) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO,
                 STAMPFactory.eINSTANCE.createHazardScenario()));
    }

    /**
     * @generated NOT
     */
    @Override
    public Object generateInitialValue(final Object owner, final Object feature) {
        if (feature == STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID) {
            final String prefix = "H";
            return Facets.generateName((EObject) owner, STAMPPlugin.FACET_SYMBOLIC_NAME, prefix,
                    STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID);
        } else if (feature == STAMPPackage.Literals.IDENTIFIED_ELEMENT__DESCRIPTION) {
            return Messages.HazardCausalFactorItemProvider_default_description_label;
        }
        return super.generateInitialValue(owner, feature);
    };

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(final EditingDomain domain, final Object object,
            final Collection<Object> collection) {
        final HazardCausalFactor hcf = (HazardCausalFactor) object;
        collection.addAll(hcf.getCountermeasures());
    }

    /**
     * @generated NOT
     */
    @Override
    public Collection<?> getIntentionDomains(final Object object) {
        return EFeaturePath.builder()
                .add(STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION)
                .addInverse(STAMPNotationPackage.Literals.HCF_TABLE__UNSAFE_CONTROL_ACTION).create()
                .getReferences((HazardCausalFactor) object);
    }

}
