/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

import net.astah.project.Facets;
import net.astah.stpa.stamp.Hazard;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STAMPPlugin;
import net.astah.stpa.stamp.edit.Messages;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.Hazard} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class HazardItemProvider extends IdentifiedElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HazardItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addSafetyConstraintPropertyDescriptor(object);
            addAccidentPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Safety Constraint feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSafetyConstraintPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Hazard_safetyConstraint_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Hazard_safetyConstraint_feature", "_UI_Hazard_type"),
                 STAMPPackage.Literals.HAZARD__SAFETY_CONSTRAINT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Accident feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addAccidentPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Hazard_accident_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Hazard_accident_feature", "_UI_Hazard_type"),
                 STAMPPackage.Literals.HAZARD__ACCIDENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns Hazard.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/Hazard"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((Hazard)object).getId();
        return label == null || label.length() == 0 ?
            getString("_UI_Hazard_type") :
            getString("_UI_Hazard_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @generated NOT
     */
    @Override
    public Object generateInitialValue(Object owner, Object feature) {
        if (feature == STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID) {
            String prefix = "H-";
            return Facets.generateName((EObject) owner, STAMPPlugin.FACET_SYMBOLIC_NAME, prefix,
                    STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID);
        } else if (feature == STAMPPackage.Literals.IDENTIFIED_ELEMENT__DESCRIPTION) {
            return Messages.HazardItemProvider_default_description_label;
        }
        return super.generateInitialValue(owner, feature);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(EditingDomain domain,
            Object object,
            Collection<Object> collection) {
        Hazard owner = (Hazard) object;
        collection.addAll(owner.getSafetyConstraints());
    }

}
