/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.emf.edit.command.DeferringCommandWrapper;
import net.astah.project.Facets;
import net.astah.stpa.stamp.NamedElement;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STAMPPlugin;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.NamedElement} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class NamedElementItemProvider extends ElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NamedElementItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addNamePropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Name feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addNamePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_NamedElement_name_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_NamedElement_name_feature", "_UI_NamedElement_type"),
                 STAMPPackage.Literals.NAMED_ELEMENT__NAME,
                 true,
                 false,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This returns NamedElement.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/NamedElement"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((NamedElement)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_NamedElement_type") :
            getString("_UI_NamedElement_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(NamedElement.class)) {
            case STAMPPackage.NAMED_ELEMENT__NAME:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createInitializeFeatureCommand(EditingDomain domain, EObject owner, EStructuralFeature feature) {
        Command command = super.createInitializeFeatureCommand(domain, owner, feature);
        if (feature == STAMPPackage.Literals.NAMED_ELEMENT__NAME) {
            command = new DeferringCommandWrapper(command);
        }
        return command;
    }

    /**
     * @generated NOT
     */
    @Override
    public Object generateInitialValue(Object owner, Object feature) {
        if (feature == STAMPPackage.Literals.NAMED_ELEMENT__NAME) {
            NamedElement eOwner = (NamedElement) owner;
            String prefix = getTypeText(owner);
            return Facets.generateName(eOwner, STAMPPlugin.FACET_SYMBOLIC_NAME, prefix,
                    STAMPPackage.Literals.NAMED_ELEMENT__NAME);
        }
        return super.generateInitialValue(owner, feature);
    }

    /**
     * @generated NOT
     */
    @Override
    public String getModelTreeText(Object object) {
        return ((NamedElement) object).getName();
    }

    /**
     * @generated NOT
     */
    @Override
    protected EStructuralFeature getLabelFeature() {
        return STAMPPackage.Literals.NAMED_ELEMENT__NAME;
    }

    /**
     * @see STAMPItemProviderAdapter#getTableCellText(Object)
     * @generated NOT
     */
    @Override
    public String getTableCellText(Object object) {
        return ((NamedElement) object).getName();
    }

    @Override
    public Object getStyledText(Object object) {
        return ((NamedElement) object).getName();
    }

}
