/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EStructuralFeature.Setting;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.uml2.common.edit.command.SubsetAddCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetReplaceCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetSetCommand;
import org.eclipse.uml2.common.edit.command.SupersetRemoveCommand;
import org.eclipse.uml2.common.util.UML2Util;

import net.astah.emf.edit.command.SupersetMoveCommand;
import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.UCAAnalysis;
import net.astah.stpa.stamp.UCAAnalysisResult;
import net.astah.stpa.stamp.UnsafeControlAction;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.UCATable;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.UCAAnalysisResult} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class UCAAnalysisResultItemProvider extends ElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAAnalysisResultItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addResultElementPropertyDescriptor(object);
            addUnsafeControlActionPropertyDescriptor(object);
            addControlActionPropertyDescriptor(object);
            addGuideWordPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Result Element feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addResultElementPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_UCAAnalysisResult_resultElement_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_UCAAnalysisResult_resultElement_feature", "_UI_UCAAnalysisResult_type"),
                 STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Unsafe Control Action feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addUnsafeControlActionPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_UCAAnalysisResult_unsafeControlAction_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_UCAAnalysisResult_unsafeControlAction_feature", "_UI_UCAAnalysisResult_type"),
                 STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Control Action feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addControlActionPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_UCAAnalysisResult_controlAction_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_UCAAnalysisResult_controlAction_feature", "_UI_UCAAnalysisResult_type"),
                 STAMPPackage.Literals.UCA_ANALYSIS_RESULT__CONTROL_ACTION,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Guide Word feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGuideWordPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_UCAAnalysisResult_guideWord_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_UCAAnalysisResult_guideWord_feature", "_UI_UCAAnalysisResult_type"),
                 STAMPPackage.Literals.UCA_ANALYSIS_RESULT__GUIDE_WORD,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns UCAAnalysisResult.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/UCAAnalysisResult"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_UCAAnalysisResult_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(UCAAnalysisResult.class)) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createAddCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection, int)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION) {
            return new SubsetAddCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT}, collection, index);
        }
        if (feature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE) {
            return new SubsetAddCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT}, collection, index);
        }
        return super.createAddCommand(domain, owner, feature, collection, index);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createRemoveCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SupersetRemoveCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, collection);
        }
        return super.createRemoveCommand(domain, owner, feature, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createReplaceCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createReplaceCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value, Collection<?> collection) {
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value, collection);
        }
        if (feature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value, collection);
        }
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, null, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, value, collection);
        }
        return super.createReplaceCommand(domain, owner, feature, value, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createSetCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createSetCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value) {
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION) {
            return new SubsetSupersetSetCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value);
        }
        if (feature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE) {
            return new SubsetSupersetSetCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value);
        }
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SubsetSupersetSetCommand(domain, owner, feature, null, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, value);
        }
        return super.createSetCommand(domain, owner, feature, value);
    }

    /**
     * resultElementsはownedNotesおよびUCAをsubsetsとして持つため、
     * 移動の際はsubsetsのリストの要素も移動させる必要がある。
     * @generated NOT
     */
    @Override
    protected Command createMoveCommand(EditingDomain domain, EObject owner,
            EStructuralFeature feature, Object value, int index) {
        if (feature == STAMPPackage.Literals.UCA_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SupersetMoveCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, value, index);
        }
        return super.createMoveCommand(domain, owner, feature, value, index);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(EditingDomain domain,
            Object object,
            Collection<Object> collection) {
        UCAAnalysisResult owner = (UCAAnalysisResult) object;
        collection.addAll(owner.getUnsafeControlActions());
    }

    /**
     * @generated NOT
     */
    @Override
    public Collection<?> getIntentionDomains(Object object) {
        EObject eContainer = ((EObject) object).eContainer();
        if (eContainer instanceof UCAAnalysis) {
            // このオブジェクトを参照しているUCA表を探索する
            return UML2Util.getNonNavigableInverseReferences(eContainer).stream()
                    .filter(setting -> {
                        EStructuralFeature feature = setting.getEStructuralFeature();
                        if (feature != STAMPNotationPackage.Literals.UCA_TABLE__ANALYSIS) {
                            return false;
                        }
                        UCATable table = (UCATable) setting.getEObject();
                        return table.getResults().contains(object);
                    }).map(Setting::getEObject).collect(Collectors.toList());
        }
        return Collections.emptySet();
    }

    /**
     * @see STAMPItemProviderAdapter#getTableCellText(Object)
     * @generated NOT
     */
    @Override
    public String getTableCellText(final Object object) {
        final StringBuffer ucaText = new StringBuffer();
        for (Element element : ((UCAAnalysisResult) object).getResultElements()) {
            if (element instanceof UnsafeControlAction) {
                UnsafeControlAction uca = (UnsafeControlAction) element;
                ucaText.append("(" + uca.getId() + ") ");
                ucaText.append(uca.getDescription());
                if (!uca.getViolatingSafetyConstraints().isEmpty()) {
                    ucaText.append("\n");
                    uca.getViolatingSafetyConstraints()
                            .forEach(sc -> ucaText.append("[" + sc.getId() + "]"));
                }
                ucaText.append("\n");
            } else if (element instanceof Note) {
                ucaText.append(((Note) element).getBody() + "\n");
            }
        }
        return ucaText.toString();
    }

}
