package net.astah.stpa.stamp.provider;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import net.astah.dd.di.edit.provider.IItemGraphicalStyleProvider;
import net.astah.emf.edit.provider.AstahItemProviderAdapter;
import net.astah.emf.edit.provider.ExtraLabelVariant;
import net.astah.emf.edit.provider.IItemComparatorProvider;
import net.astah.emf.edit.provider.IItemDependencyProvider;
import net.astah.emf.edit.provider.IItemDiagramProvider;
import net.astah.emf.edit.provider.IItemLabelPropertySource;
import net.astah.emf.edit.provider.IItemMatchProvider;
import net.astah.emf.edit.provider.IItemVariantLabelPropertySource;
import net.astah.emf.edit.provider.IItemVariantLabelProvider;

/**
 * STAMP/STPA メタモデル用の {@code ItemProviderAdapter} の基本クラスです。
 */
public class STAMPItemProviderAdapter extends AstahItemProviderAdapter implements
        IEditingDomainItemProvider,
        IStructuredItemContentProvider,
        ITreeItemContentProvider,
        IItemLabelProvider,
        IItemFontProvider,
        IItemColorProvider,
        IItemPropertySource,
        IItemLabelPropertySource,
        IItemVariantLabelPropertySource,
        IItemVariantLabelProvider,
        IItemComparatorProvider,
        IItemDependencyProvider,
        IItemDiagramProvider,
        IItemMatchProvider,
        IItemGraphicalStyleProvider {

    public STAMPItemProviderAdapter(final AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String getText(Object object, Object variant) {
        if (variant == ExtraLabelVariant.MODEL_TREE) {
            return getModelTreeText(object);
        } else if (variant == ExtraLabelVariant.MODEL_LIST) {
            return getModelListText(object);
        } else if (variant == ExtraLabelVariant.FULL) {
            return getTableCellText(object);
        }
        return super.getText(object, variant);
    }

    /**
     * @see ExtraLabelVariant#MODEL_TREE
     */
    public String getModelTreeText(Object object) {
        return getText(object);
    }

    /**
     * @see ExtraLabelVariant#MODEL_LIST
     */
    public String getModelListText(Object object) {
        return getText(object);
    }

    /**
     * @see ExtraLabelVariant#FULL
     */
    public String getTableCellText(Object object) {
        return getText(object);
    }

    @Override
    public Object getGraphicalStyle(Object object, Object feature) {
        return null;
    }
}
