/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.uml2.common.edit.command.SubsetAddCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetReplaceCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetSetCommand;
import org.eclipse.uml2.common.edit.command.SupersetRemoveCommand;

import com.google.common.collect.Sets;

import net.astah.dd.dc.Bounds;
import net.astah.dd.dc.DCFactory;
import net.astah.dd.dc.Dimension;
import net.astah.dd.dc.Point;
import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.edit.provider.IItemGeometryProvider;
import net.astah.dd.di.edit.provider.LayoutCalculator;
import net.astah.emf.common.ecore.DataTypeEObject;
import net.astah.emf.common.notify.EFeaturePath;
import net.astah.notation.Shape;
import net.astah.notation.edit.layout.AlignKind;
import net.astah.notation.edit.layout.FlowLayout;
import net.astah.notation.edit.layout.Layout;
import net.astah.notation.edit.layout.ModelElementLayoutInfo;
import net.astah.notation.edit.layout.TextAreaLayout;
import net.astah.notation.edit.provider.IItemLayoutProvider;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.notation.STAMPCompartment;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationFactory;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.edit.layout.LayoutUtil;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPCompartment} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPCompartmentItemProvider extends STAMPDiagramElementItemProvider {
    public static final FlowLayout LAYOUT = new FlowLayout.Builder()
            .add(new TextAreaLayout.Builder(LayoutUtil.TEXT_AREA)
                    .margin(5, 10)
                    .minWidth(30)
                    .textAlign(AlignKind.LEFT)
                    .lineWrappable(true)
                    .path(EFeaturePath.build(STAMPNotationPackage.Literals.STAMP_LABEL__TEXT))
                    .modelElementLayoutInfos(Sets.newHashSet(
                            new ModelElementLayoutInfo(STAMPPackage.Literals.PROCESS_VARIABLE, 0,
                                    "* "),
                            new ModelElementLayoutInfo(STAMPPackage.Literals.PROCESS_VALUE, 10,
                                    "- "))))
            .build();

    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPCompartmentItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addElementInCompartmentPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Element In Compartment feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addElementInCompartmentPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPCompartment_elementInCompartment_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPCompartment_elementInCompartment_feature", "_UI_STAMPCompartment_type"),
                 STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns STAMPCompartment.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPCompartment"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_STAMPCompartment_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STAMPCompartment.class)) {
            case STAMPNotationPackage.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPEdge()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPLabel()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartment()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartmentableShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPComponentShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPGraphicalShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlStructureDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlLoopDiagram()));
    }

    /**
     * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
        Object childFeature = feature;
        Object childObject = child;

        boolean qualify =
            childFeature == STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT ||
            childFeature == STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT;

        if (qualify) {
            return getString
                ("_UI_CreateChild_text2",
                 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
        }
        return super.getCreateChildText(owner, feature, child, selection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createAddCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection, int)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
        if (feature == STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT) {
            return new SubsetAddCommand(domain, owner, feature, new EStructuralFeature[] {STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT}, collection, index);
        }
        return super.createAddCommand(domain, owner, feature, collection, index);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createRemoveCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
        if (feature == STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT) {
            return new SupersetRemoveCommand(domain, owner, feature, new EStructuralFeature[] {STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT}, collection);
        }
        return super.createRemoveCommand(domain, owner, feature, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createReplaceCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createReplaceCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value, Collection<?> collection) {
        if (feature == STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, new EStructuralFeature[] {STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT}, null, value, collection);
        }
        if (feature == STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, null, new EStructuralFeature[] {STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT}, value, collection);
        }
        return super.createReplaceCommand(domain, owner, feature, value, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createSetCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createSetCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value) {
        if (feature == STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT) {
            return new SubsetSupersetSetCommand(domain, owner, feature, new EStructuralFeature[] {STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT}, null, value);
        }
        if (feature == STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT) {
            return new SubsetSupersetSetCommand(domain, owner, feature, null, new EStructuralFeature[] {STAMPNotationPackage.Literals.STAMP_COMPARTMENT__ELEMENT_IN_COMPARTMENT}, value);
        }
        return super.createSetCommand(domain, owner, feature, value);
    }

    @Override
    public void collectDependents(EditingDomain domain, Object object,
            Collection<Object> collection) {
        final STAMPCompartment shape = (STAMPCompartment) object;
        collection.addAll(shape.getSTAMPOwnedElements());
        super.collectDependents(domain, object, collection);
    }

    /**
     * @see IItemGeometryProvider#getBoundsOn(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Bounds getBoundsOn(final Object object, final LayoutCalculator layoutCalculator) {
        final Point location = getLocationOn(object, layoutCalculator);
        if (location == null) {
            return null;
        }
        double width = 0;
        double height = 0;
        final Dimension size = getBoundsSize(object, layoutCalculator);
        if (size != null) {
            width = size.getWidth();
            height = size.getHeight();
        }
        return DCFactory.eINSTANCE.createBounds(location.getX(), location.getY(), width, height);
    }

    /**
     * @see IItemGeometryProvider#getLocationOn(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getLocationOn(final Object object, final LayoutCalculator layoutCalculator) {
        final STAMPCompartment compartment = (STAMPCompartment) object;
        final STAMPDiagramElement owner = layoutCalculator.getOwningElement(compartment);
        final Bounds componentNameBounds = LayoutUtil.getComponentNameBounds((Shape) owner,
                layoutCalculator);
        double offsetY = componentNameBounds.getHeight();
        final List<DiagramElement> elements = layoutCalculator.getOwnedElements(owner);
        for (final DiagramElement element : elements) {
            if (element.equals(compartment)) {
                break;
            }
            if (!(element instanceof STAMPCompartment)) {
                continue;
            }
            final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
            LAYOUT.calculateTotalBounds(compartment, null,
                    LayoutUtil.createChildrenMap(layoutCalculator.getOwnedElements(element)),
                    layoutCalculator, totalBounds);
            offsetY += totalBounds.getHeight();
        }
        return DCFactory.eINSTANCE.createPoint(componentNameBounds.getX(), offsetY);
    }

    /**
     * @see IItemGeometryProvider#getBoundsSize(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Dimension getBoundsSize(final Object object, final LayoutCalculator layoutCalculator) {
        final Object owner = getOriginatingElement(object, layoutCalculator);
        return layoutCalculator.getElementSize(owner, object);
    }

    /**
     * @see IItemGeometryProvider#getElementLocationOn(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getElementLocationOn(final Object object, final Object element,
            final LayoutCalculator layoutCalculator) {
        final STAMPCompartment compartment = (STAMPCompartment) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(compartment);
        final Map<String, List<DiagramElement>> childrenMap = LayoutUtil
                .createChildrenMap(children);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        LAYOUT.calculateTotalBounds(compartment,
                (Shape) layoutCalculator.getOwningElement(compartment), childrenMap,
                layoutCalculator, totalBounds);
        final Map<DiagramElement, DataTypeEObject> result = LAYOUT.calculate(childrenMap,
                totalBounds, layoutCalculator, Point.class);
        return (Point) result.get(element);
    }

    /**
     * @see IItemGeometryProvider#getElementSize(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Dimension getElementSize(final Object object, final Object element,
            final LayoutCalculator layoutCalculator) {
        final STAMPCompartment compartment = (STAMPCompartment) object;
        final List<DiagramElement> elements = layoutCalculator.getOwnedElements(compartment);
        final Map<String, List<DiagramElement>> childrenMap = LayoutUtil
                .createChildrenMap(elements);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        LAYOUT.calculateTotalBounds(compartment, null, childrenMap, layoutCalculator, totalBounds);
        final Map<DiagramElement, DataTypeEObject> result = LAYOUT.calculate(childrenMap,
                totalBounds, layoutCalculator, Dimension.class);
        return (Dimension) result.get(element);
    }

    /**
     * @see IItemGeometryProvider#getElementOrigin(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getElementOrigin(final Object object, final Object child,
            final LayoutCalculator layoutCalculator) {
        if (child instanceof STAMPLabel) {
            return getElementLocationOn(object, child, layoutCalculator);
        }
        return getLocationOn(object, layoutCalculator);
    }

    /**
     * @see IItemLayoutProvider#getLayout(Object)
     * @generated NOT
     */
    @Override
    public Layout getLayout(Object object) {
        return LAYOUT;
    }
}
