/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.CopyCommand.Helper;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import com.google.common.collect.Iterables;

import net.astah.dd.dc.Bounds;
import net.astah.dd.dc.DCFactory;
import net.astah.dd.dc.Dimension;
import net.astah.dd.dc.Point;
import net.astah.dd.di.DIPackage;
import net.astah.dd.di.Diagram;
import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.edit.provider.IItemGeometryProvider;
import net.astah.dd.di.edit.provider.LayoutCalculator;
import net.astah.dd.di.util.DiagramElements;
import net.astah.emf.common.ecore.DataTypeEObject;
import net.astah.emf.common.ecore.EObjects;
import net.astah.emf.common.notify.EFeaturePath;
import net.astah.emf.edit.provider.ExtraLabelVariant;
import net.astah.emf.edit.provider.LabelProviders;
import net.astah.notation.edit.layout.FlowLayout;
import net.astah.notation.edit.layout.FreeLayout;
import net.astah.notation.edit.layout.Layout;
import net.astah.notation.edit.layout.TextAreaLayout;
import net.astah.notation.provider.ShapeItemProvider;
import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.LinkEnd;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationFactory;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.STAMPShape;
import net.astah.stpa.stamp.notation.edit.command.InitializeSTAMPDiagramElementCommand;
import net.astah.stpa.stamp.notation.edit.command.STAMPDiagramElementCopyCommand;
import net.astah.stpa.stamp.notation.edit.layout.LayoutUtil;
import net.astah.stpa.stamp.util.STAMPSwitch;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPShape} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPShapeItemProvider extends ShapeItemProvider {
    public static final FlowLayout NOTE_LAYOUT;
    public static final FlowLayout LINKEND_LAYOUT;

    static {
        NOTE_LAYOUT = new FlowLayout.Builder().minWidth(25).minHeight(23)
                .add(new TextAreaLayout.Builder(LayoutUtil.TEXT_AREA).topMargin(2).bottomMargin(2)
                        .leftMargin(2).rightMargin(10).minWidth(21).lineWrappable(true)
                        .path(EFeaturePath.build(STAMPNotationPackage.Literals.STAMP_LABEL__TEXT))
                        .widthStretch(true).heightStretch(true))
                .build();

        LINKEND_LAYOUT = new FlowLayout.Builder().minWidth(7).minHeight(7)
                .add(new FreeLayout.Builder(LayoutUtil.FREE)).build();
    }

    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPShapeItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addSTAMPModelElementPropertyDescriptor(object);
            addSTAMPTargetEdgePropertyDescriptor(object);
            addSTAMPSourceEdgePropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the STAMP Model Element feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPModelElementPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPModelElement_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPModelElement_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Target Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPTargetEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPTargetEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPTargetEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Source Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPSourceEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPSourceEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPSourceEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns STAMPShape.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPShape"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        STAMPShape stampShape = (STAMPShape)object;
        return getString("_UI_STAMPShape_type") + " " + stampShape.isVisible();
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STAMPShape.class)) {
            case STAMPNotationPackage.STAMP_SHAPE__STAMP_OWNED_ELEMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPEdge()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPLabel()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartment()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartmentableShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPComponentShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPGraphicalShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlStructureDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlLoopDiagram()));
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return STAMPNotationEditPlugin.INSTANCE;
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createCreateChildCommand(EditingDomain domain,
            EObject owner,
            EStructuralFeature feature,
            Object value,
            int index,
            Collection<?> collection) {
        Command command =
                super.createCreateChildCommand(domain, owner, feature, value, index, collection);
        if (feature == DIPackage.Literals.DIAGRAM_ELEMENT__OWNED_ELEMENT) {
            command = new InitializeSTAMPDiagramElementCommand(domain, owner, value, index).chain(command);
        }
        return command;
    }

    @Override
    protected Command createCopyCommand(EditingDomain domain, Object context, EObject owner,
            Helper helper) {
        return new STAMPDiagramElementCopyCommand(domain, context, owner, helper, domain.getOptimizeCopy());
    }

    @Override
    public String getModelTreeText(final Object object) {
        final STAMPShape shape = (STAMPShape) object;
        return DiagramElements.mapModelElement(shape, modelElement -> {
            return LabelProviders.getText(modelElement, ExtraLabelVariant.MODEL_TREE);
        }, "");
    }

    /**
     * @see IItemGeometryProvider#getLocationOn(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getLocationOn(final Object object, final LayoutCalculator layoutCalculator) {
        final STAMPShape shape = (STAMPShape) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(shape);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        getLayout(shape).calculateTotalBounds(shape, shape, LayoutUtil.createChildrenMap(children),
                layoutCalculator, totalBounds);
        return DCFactory.eINSTANCE.createPoint(totalBounds.getX(), totalBounds.getY());
    }

    /**
     * @see IItemGeometryProvider#getBoundsSize(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Dimension getBoundsSize(final Object object, final LayoutCalculator layoutCalculator) {
        final STAMPShape shape = (STAMPShape) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(shape);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        getLayout(shape).calculateTotalBounds(shape, shape, LayoutUtil.createChildrenMap(children),
                layoutCalculator, totalBounds);
        return DCFactory.eINSTANCE.createDimension(totalBounds.getWidth(), totalBounds.getHeight());
    }

    /**
     * @see IItemGeometryProvider#getElementLocationOn(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getElementLocationOn(final Object object, final Object element,
            final LayoutCalculator layoutCalculator) {
        final STAMPShape shape = (STAMPShape) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(shape);
        final Map<String, List<DiagramElement>> childrenMap = LayoutUtil
                .createChildrenMap(children);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        getLayout(shape).calculateTotalBounds(shape, shape, childrenMap, layoutCalculator,
                totalBounds);
        final Map<DiagramElement, DataTypeEObject> result = ((Layout) getLayout(shape))
                .calculate(childrenMap, totalBounds, layoutCalculator, Point.class);
        return (Point) result.get(element);
    }

    /**
     * @see IItemGeometryProvider#getElementSize(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Dimension getElementSize(final Object object, final Object element,
            final LayoutCalculator layoutCalculator) {
        final STAMPShape shape = (STAMPShape) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(shape);
        final Map<String, List<DiagramElement>> childrenMap = LayoutUtil
                .createChildrenMap(children);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        getLayout(shape).calculateTotalBounds(shape, shape, childrenMap, layoutCalculator,
                totalBounds);
        final Map<DiagramElement, DataTypeEObject> result = ((Layout) getLayout(shape))
                .calculate(childrenMap, totalBounds, layoutCalculator, Dimension.class);
        return (Dimension) result.get(element);
    }

    /**
     * @see IItemGeometryProvider#getElementOrigin(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getElementOrigin(final Object object, final Object child,
            final LayoutCalculator layoutCalculator) {
        if (child instanceof STAMPLabel) {
            return getElementLocationOn(object, child, layoutCalculator);
        }
        return super.getLocationOn(object, layoutCalculator);
    }

    @Override
    protected boolean adjustCopySelection(EditingDomain domain, Object owner,
            Set<Object> selection) {
        final STAMPShape presentation = (STAMPShape) owner;

        boolean changed = false;
        for (STAMPLabel child : Iterables.filter(presentation.getOwnedElements(),
                STAMPLabel.class)) {
            changed |= selection.remove(child);
        }

        return super.adjustCopySelection(domain, owner, selection) || changed;
    }

    @Override
    protected boolean isDependingFeature(final EditingDomain domain, final EObject eObject,
            final EStructuralFeature feature, final Object value, final Collection<?> collection) {
        if (feature == STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT) {
            return isDependingFeature(eObject, feature, value, 1);
        }
        return super.isDependingFeature(domain, eObject, feature, value, collection);
    }

    @Override
    public void collectDependents(final EditingDomain domain, final Object object,
            final Collection<Object> collection) {
        final STAMPShape shape = (STAMPShape) object;
        for (final Element element : shape.getSTAMPModelElements()) {
            if (element instanceof Note) {
                if (!collection.contains(element)) {
                    collection.add(element);
                }
            }
        }
        super.collectDependents(domain, object, collection);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(EditingDomain domain, Object object,
            Collection<Object> collection) {
        STAMPShape shape = (STAMPShape) object;
        for (Element element : shape.getSTAMPModelElements()) {
            if (element instanceof LinkEnd) {
                collection.add(element);
            }
        }
        super.collectSharedComposites(domain, object, collection);
    }

    @Override
    public Layout getLayout(Object object) {
        if (object instanceof STAMPShape) {
            object = DiagramElements.getModelElement((STAMPShape) object);
        }

        STAMPSwitch<Layout> modelSwitch = new STAMPSwitch<Layout>() {
            @Override
            public Layout caseLinkEnd(LinkEnd object) {
                return LINKEND_LAYOUT;
            }

            @Override
            public Layout caseNote(Note object) {
                return NOTE_LAYOUT;
            }

            @Override
            public Layout defaultCase(EObject object) {
                throw new UnsupportedOperationException();
            }
        };

        return modelSwitch.doSwitch((EObject) object);
    }

    @Override
    protected boolean adjustDeleteDiagramElementSelection(final EditingDomain domain,
            final Object owner, final Set<Object> selection) {
        final STAMPShape shape = (STAMPShape) owner;
        boolean changed = super.adjustDeleteDiagramElementSelection(domain, owner, selection);

        changed |= DiagramElements.mapModelElement(shape, LinkEnd.class, linkEnd -> {
            if (selection.contains(shape)
                    && isOnlyUsedModel(linkEnd, EObjects.getAncestor(Diagram.class, shape))) {
                return selection.add(linkEnd);
            } else {
                return false;
            }
        }, false);

        return changed;
    }

    private boolean isOnlyUsedModel(final EObject modelElement, final Diagram diagram) {
        final EFeaturePath path = EFeaturePath
                .build(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT);
        for (final DiagramElement element : Iterables
                .filter(path.getInverseReferences(modelElement), DiagramElement.class)) {
            if (EObjects.getAncestor(Diagram.class, element) != diagram) {
                return false;
            }
        }
        return true;
    }

}
