package net.astah.stpa.stamp.notation.provider;

import java.io.IOException;
import java.net.URL;

import net.astah.emf.common.util.StandaloneInternalHelper;
import net.astah.emf.edit.provider.ItemProviders;

/**
 * STAMPNotation edit プラグインのヘルパークラスです。
 */
public class STAMPNotationEditPluginHelper extends STAMPNotationEditPlugin.Implementation {

    /**
     * コンストラクタ
     * 
     * @param baseURL
     *            プラグインの URL
     */
    public STAMPNotationEditPluginHelper(final URL baseURL) {
        helper = new StandaloneInternalHelper(this, baseURL);
    }

    /**
     * 初期化処理を実行します。
     */
    public static void init() {
        if (STAMPNotationEditPlugin.getPlugin() == null) {
            new STAMPNotationEditPluginHelper(STAMPNotationEditPlugin.INSTANCE.getBaseURL());
        }
    }

    @Override
    public String getSymbolicName() {
        return "net.astah.stpa.stamp.notation.edit";
    }

    @Override
    protected Object doGetImage(String key) throws IOException {
        return ItemProviders.getImage(getBaseURL(), "icons/", key, ".png");
    }
}
