package net.astah.stpa.stamp.notation.editor;

import net.astah.golf.geom2D.Pnt2d;
import net.astah.notation.editor.GraphicalStyles;
import net.astah.notation.editor.IMovableViewElement;
import net.astah.notation.editor.ITransformer;
import net.astah.notation.editor.ShapeTransformer;
import net.astah.stpa.stamp.notation.STAMPComponentShape;

/**
 * コンポーネント要素の省略表記を表示するためのビューエレメントを実装するクラスです。
 */
public class STAMPOmittedComponentViewElement extends STAMPComponentBaseViewElement
        implements IMovableViewElement {

    private static final byte FRAME_COLOR = BLACK;
    private static final byte BODY_COLOR = WHITE;
    private static final byte KNOB_COLOR = BLACK;
    private static final byte SHADOW_COLOR = LIGHTGRAY;

    public STAMPOmittedComponentViewElement(STAMPComponentShape model) {
        super(model);
    }

    @Override
    protected void updateColor() {
        GraphicalStyles.applyFillColor(bodyRect, getModel(), BODY_COLOR);
        GraphicalStyles.applyStrokeColor(bodyRect, getModel(), FRAME_COLOR);

        bodyRect.setKnobColorNo(KNOB_COLOR);
        bodyRect.setShadowColorNo(SHADOW_COLOR);
    }

    @Override
    public ITransformer startMove(Pnt2d startLocation) {
        return new ShapeTransformer(this, startLocation);
    }

}
