package net.astah.stpa.stamp.ui.control;

import static java.util.Collections.singletonList;

import net.astah.golf.control.Command;
import net.astah.jomt.jcontrol.CreateNewPrjCommand;
import net.astah.jomt.jcontrol.CreateNewPrjSeqCommand;
import net.astah.stpa.stamp.STAMPPlugin;

/**
 * STAMP/STPA プロジェクトを新規作成するコマンドです。
 */
public class CreateNewSTAMPPrjSeqCommand extends CreateNewPrjSeqCommand {

    @Override
    protected Command createCreateNewPrjCommand() {
        CreateNewPrjCommand newPrjCmd = new CreateNewPrjCommand();
        newPrjCmd.setTemplateFilePath(templateFilePath);
        newPrjCmd.setAPIUseDefinedTaggedValues(isAPIUseDefinedTaggedValues);
        newPrjCmd.setCreateDefaultDiagram(createDefaultDiagram);
        newPrjCmd.setCreateDefaultModel(createDefaultModel);
        newPrjCmd.setLanguageInfo(setLanguageInfo);
        newPrjCmd.setInitialFacets(singletonList(STAMPPlugin.FACET_SYMBOLIC_NAME));
        return newPrjCmd;
    }
}
