package net.astah.stpa.stamp.ui.control;

import javax.swing.JFrame;

import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.edit.domain.EditingDomain;

import net.astah.golf.control.Command;
import net.astah.golf.view.swing.UIViewPeer;
import net.astah.golf.widget.swing.SwingFrame;
import net.astah.jmodel.IJomtEntityStore;
import net.astah.jomt.jsystem.JomtGlobal;
import net.astah.jomt.jsystem.ModelGlobal;
import net.astah.jomt.jview.Editor;
import net.astah.jomt.jview.TableEditor;
import net.astah.project.Facet;
import net.astah.project.Project;
import net.astah.project.ProjectManagerAdapter;
import net.astah.stpa.stamp.STAMPPlugin;
import net.astah.stpa.stamp.STPAAnalysis;
import net.astah.stpa.stamp.ui.view.CustomizeHintWordDialog;
import net.astah.stpa.stamp.ui.view.swing.HCFTableEditorPeer;

/**
 * ヒントワードをカスタマイズするコマンドです。
 */
public class CustomizeHintWordCommand extends Command {

    @Override
    public void execute() {
        final JFrame parent = (JFrame) ((SwingFrame) JomtGlobal.viewManager.getManagementView()
                .getComponent()).getComponent();
        final net.astah.jmodel.Project currentProject = ModelGlobal.prjManager.getCurrentProject();
        final IJomtEntityStore doc = currentProject.doc;
        final EditingDomain domain = doc.getDomain();
        final ResourceSet resourceSet = domain.getResourceSet();
        final Project rootProject = ProjectManagerAdapter.getRootProject(resourceSet);
        final Facet facet = rootProject.getFacet(STAMPPlugin.FACET_SYMBOLIC_NAME);
        final STPAAnalysis analysis = (STPAAnalysis) facet.getContents().get(0);
        final CustomizeHintWordDialog dialog = new CustomizeHintWordDialog(parent, analysis);
        dialog.setVisible(true);
        // HCF表がアクティブになっている場合に、ヒントワードセットリストの更新処理を行う
        Editor editor = JomtGlobal.viewManager.getCurrentEditor();
        if (editor instanceof TableEditor) {
            UIViewPeer editorPeer = editor.getUiViewPeer();
            if (editorPeer instanceof HCFTableEditorPeer) {
                ((HCFTableEditorPeer) editorPeer).tableEditorActivated(null);
            }
        }
        dialog.dispose();
    }

}
