package net.astah.stpa.stamp.ui.menu.handler;

import java.awt.event.ActionEvent;
import java.util.List;

import net.astah.golf.widget.ISelection;
import net.astah.jomt.jcontrol.SelectAllCommand;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.ui.menu.annotation.Execute;
import net.astah.ui.menu.annotation.Handler;
import net.astah.ui.menu.annotation.KeyBinding;
import net.astah.ui.menu.annotation.MenuCommand;
import net.astah.ui.menu.annotation.MenuItem;
import net.astah.ui.menu.annotation.MenuItem.ItemKind;

/**
 * 図上の図要素をすべて選択します。
 */
@Handler(targets = { STAMPControlStructureDiagram.class,
        STAMPControlLoopDiagram.class })
@MenuItem(label = "%StampControlStructureDiagram_selectAll_label",
        tooltip = "%StampControlStructureDiagram_selectAll_tooltip",
        type = ItemKind.CHECK)
@MenuCommand(id = "stpa.SelectAllCommand",
        category = "edit.select_show")
@KeyBinding(keySequence = "control A")
public class SelectAllHandler {

    /**
     * 図上の図要素をすべて選択するコマンドを実行します。
     * 
     * @param selection
     *            選択要素
     * @param params
     *            コマンドのパラメータ
     * @param e
     *            アクションイベント
     */
    @Execute
    public void execute(final ISelection selection, final List<String> params,
            final ActionEvent e) {
        final SelectAllCommand command = new SelectAllCommand();
        command.execute();
    }

}
