package net.astah.stpa.stamp.ui.menu.handler;

import java.awt.event.ActionEvent;
import java.util.List;

import net.astah.golf.widget.ISelection;
import net.astah.jomt.jcontrol.ZoomViewCommand;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.ui.menu.annotation.Execute;
import net.astah.ui.menu.annotation.Handler;
import net.astah.ui.menu.annotation.KeyBinding;
import net.astah.ui.menu.annotation.MenuCommand;
import net.astah.ui.menu.annotation.MenuItem;
import net.astah.ui.menu.annotation.MenuItem.ItemKind;

/**
 * 図の表示を標準(1倍)にします。
 */
@Handler(targets = { STAMPControlStructureDiagram.class,
        STAMPControlLoopDiagram.class })
@MenuItem(label = "%StampControlStructureDiagram_zoom_label",
        iconURI = "platform:/plugin/net.astah.core.app/net/astah/jomt/resource/images/zoom1.png",
        tooltip = "%StampControlStructureDiagram_zoom_tooltip",
        type = ItemKind.PUSH)
@MenuCommand(id = "stpa.ZoomViewCommand",
        category = "edit.zoom")
@KeyBinding(keySequence = "control 1")
public class ZoomViewHandler {

    /**
     * 図の表示を標準(1倍)にするコマンドを実行します。
     * 
     * @param selection
     *            選択要素
     * @param params
     *            コマンドのパラメータ
     * @param e
     *            アクションイベント
     */
    @Execute
    public void execute(final ISelection selection, final List<String> params,
            final ActionEvent e) {
        final ZoomViewCommand command = new ZoomViewCommand();
        command.setUseTransaction(true);
        command.execute();
    }
}
