package net.astah.stpa.stamp.ui.view.proptab;

import static net.astah.stpa.stamp.STAMPPackage.Literals.NAMED_ELEMENT__NAME;
import static net.astah.stpa.stamp.STAMPPackage.Literals.SIGNAL__PROVIDING_CONDITION;

import java.awt.Component;

import javax.swing.JLabel;

import net.astah.stpa.stamp.Signal;
import net.astah.stpa.stamp.ui.Messages;

/**
 * コントロールアクション、フィードバックのプロパティのベースタブを実装します。
 */
public class STAMPSignalBaseTab extends STAMPModelTab {

    private static final long serialVersionUID = -6182981293982282131L;

    @Override
    void initPanelRows() {
        Signal signal = (Signal) getModel();

        // source
        Component sourceName = new JLabel(signal.getLink().getSource().getName());
        addRow(baseItemsPanel, layout, Messages.projectview_base_tab_source_label, sourceName);

        // target
        Component targetName = new JLabel(signal.getLink().getTarget().getName());
        addRow(baseItemsPanel, layout, Messages.projectview_base_tab_target_label, targetName);

        // name
        final Component name = createPropertyCellEditorComponent(NAMED_ELEMENT__NAME);
        addRow(baseItemsPanel, layout, Messages.projectview_base_tab_name_label, name);

        // providing condition
        final String providingConditionKey = Messages.projectview_base_tab_providing_condition_label;
        initMultiLineTextArea(providingConditionKey, SIGNAL__PROVIDING_CONDITION, 3);
    }

}
