package net.astah.stpa.stamp.ui.view.swing;

import static java.util.Arrays.asList;
import static java.util.Collections.singleton;
import static net.astah.stpa.stamp.STAMPPackage.Literals.CONTROL_LOOP__HINT_WORD_SET;
import static net.astah.stpa.stamp.STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR;
import static net.astah.stpa.stamp.STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION;
import static net.astah.stpa.stamp.STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR;
import static net.astah.stpa.stamp.STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HINT_WORD;
import static net.astah.stpa.stamp.STAMPPackage.Literals.HCF_ANALYSIS__RESULT;
import static net.astah.stpa.stamp.STAMPPackage.Literals.IDENTIFIED_ELEMENT__DESCRIPTION;
import static net.astah.stpa.stamp.STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID;
import static net.astah.stpa.stamp.STAMPPackage.Literals.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR;
import static org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain.getEditingDomainFor;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.CreateChildCommand;
import org.eclipse.emf.edit.command.MoveCommand;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.IItemProviderDecorator;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.common.base.Objects;

import net.astah.dd.di.Diagram;
import net.astah.emf.common.ecore.EComparators;
import net.astah.emf.common.ecore.EcoreCopier;
import net.astah.emf.common.notify.EFeaturePath;
import net.astah.emf.edit.command.DestroyCommand;
import net.astah.emf.edit.job.CommandJob;
import net.astah.emf.edit.job.Jobs;
import net.astah.emf.edit.provider.ExtraLabelVariant;
import net.astah.emf.edit.provider.ItemProviders;
import net.astah.emf.edit.provider.swing.AdapterFactoryVariantLabelProvider;
import net.astah.emf.edit.provider.swing.JTableBuilder;
import net.astah.emf.edit.provider.swing.PropertyEditorFactory;
import net.astah.emf.edit.provider.swing.PropertyEditorFactory.Registry;
import net.astah.emf.edit.provider.swing.PropertyEditorFactoryRegistryImpl;
import net.astah.emf.edit.provider.swing.editor.SingleEReferenceCellEditor;
import net.astah.emf.edit.provider.swing.renderer.LabelProviderListCellRenderer;
import net.astah.golf.control.CommandEvent;
import net.astah.golf.control.CommandManager;
import net.astah.golf.model.EntityStoreEvent;
import net.astah.golf.widget.CJComponent;
import net.astah.golf.widget.swing.GenericTable;
import net.astah.jomt.jutil.SwingInvoker;
import net.astah.jomt.jview.DiagramEditor;
import net.astah.jomt.jview.Editor;
import net.astah.jomt.jview.MessageManager;
import net.astah.notation.TableView;
import net.astah.stpa.stamp.ControlLoop;
import net.astah.stpa.stamp.HCFAnalysis;
import net.astah.stpa.stamp.HCFAnalysisResult;
import net.astah.stpa.stamp.HCFHintWordSet;
import net.astah.stpa.stamp.HazardCausalFactor;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STPAAnalysis;
import net.astah.stpa.stamp.UnsafeControlAction;
import net.astah.stpa.stamp.notation.HCFTable;
import net.astah.stpa.stamp.ui.Messages;
import net.astah.stpa.stamp.ui.control.OpenHintWordImageCommand;
import net.astah.stpa.stamp.ui.menu.handler.AddHazardCausalFactorHandler;
import net.astah.stpa.stamp.ui.menu.handler.DeleteHazardCausalFactorHandler;
import net.astah.stpa.stamp.ui.table.HCFScenarioCellEvaluator;
import net.astah.stpa.stamp.ui.table.HCFTableColumnProvider;
import net.astah.stpa.stamp.ui.view.HCFHintWordSetFrame;
import net.astah.stpa.stamp.util.HCFHintWordSets;
import net.astah.table.DataQuery;
import net.astah.table.DynamicDataset;
import net.astah.table.Element;
import net.astah.table.ElementSet;
import net.astah.table.FixedDataset;
import net.astah.table.Grid;
import net.astah.table.IQueryExecutor;
import net.astah.table.JoinReference;
import net.astah.table.JoinType;
import net.astah.table.NativeCellDescriptor;
import net.astah.table.NativeDataQuery;
import net.astah.table.ObjectElement;
import net.astah.table.PropertyCellDescriptor;
import net.astah.table.Table;
import net.astah.table.TableFactory;
import net.astah.table.Tuple;
import net.astah.table.edit.provider.GenericTableAdapterFactory;
import net.astah.table.edit.provider.GridItemProviderDecorator;
import net.astah.table.ui.export.TableExcelExport;
import net.astah.table.ui.swing.GenericTableColumnProvider;
import net.astah.table.ui.swing.GenericTableTableTransferHandler;
import net.astah.ui.menu.annotation.Context;

/**
 * HCF表のTableEditorPeer 実装です。
 */
@Context(id = "net.astah.stpa.stamp.notation.HCFTable",
        classes = { // classesの記述順でメニューを表示する
                AddHazardCausalFactorHandler.class,
                DeleteHazardCausalFactorHandler.class
        })
public class HCFTableEditorPeer extends STPATableEditorPeer implements ActionListener {

    private static final Logger LOGGER = LoggerFactory.getLogger(HCFTableEditorPeer.class);

    /** HCF表のアノテーションのSource */
    public final static String ANNOTATION__HCF_TABLE = "hcfTable";
    /** HCFのカラムインデックス */
    public final static int HAZARD_CAUSAL_FACTOR__INDEX = 0;

    private JLabel ucaId;
    private JTextArea ucaDescription;
    private JComboBox<HCFHintWordSet> hwsComboBox;
    private JButton hwsButton;

    @Override
    public void initialize(final Diagram diagram, final CJComponent parent) {
        super.initialize(diagram, parent);
        final JTable table = (JTable) getTable().getComponent();
        table.setCellSelectionEnabled(true);
    }

    @Override
    public void update(final EntityStoreEvent e) {
        super.update(e);
        updateUcaInfo();
    }

    private void updateUcaInfo() {
        final HCFTable hcfTable = (HCFTable) getDiagram();
        if (AdapterFactoryEditingDomain.getEditingDomainFor(hcfTable) != null) {
            final ControlLoop controlLoop = hcfTable.getControlLoop();
            final UnsafeControlAction uca = hcfTable.getUnsafeControlAction();
            ucaId.setText("(" + uca.getId() + ")");
            ucaDescription.setText(uca.getDescription());
            ucaDescription.setFont(null);
            setSelectedItem(controlLoop.getHintWordSet());
        }
    }

    private void setSelectedItem(final HCFHintWordSet selectedItem) {
        if (hwsComboBox.getSelectedItem() != selectedItem) {
            hwsComboBox.setSelectedItem(selectedItem);
        }
    }

    @Override
    protected float[] getColumnsWidthRatio() {
        return new float[] { 1 / 10f, 3 / 10f, 3 / 10f, 3 / 10f };
    }

    @Override
    protected Table prepareTableModel(final TableView view) {
        final HCFTable hcfTable = (HCFTable) view;
        // 対象のHCF表をDataQueryのannotationに入れる
        final EAnnotation annotation = EcoreFactory.eINSTANCE.createEAnnotation();
        annotation.setSource(ANNOTATION__HCF_TABLE);
        annotation.getReferences().add(hcfTable);

        final NativeDataQuery row0 = TableFactory.eINSTANCE.createNativeDataQuery();
        row0.getEAnnotations().add(annotation);
        row0.setImplementationClass(HazardCausalFactorFactory.class);
        row0.setMetaclass(HAZARD_CAUSAL_FACTOR);

        final JoinReference row1 = TableFactory.eINSTANCE.createJoinReference();
        final EFeaturePath featurePath = EFeaturePath.builder()
                .addInverse(HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR).create();
        applyFeaturePath(row1, featurePath);
        row1.setJoinType(JoinType.INNER);
        row1.setOrigin(row0);

        final DynamicDataset row = TableFactory.eINSTANCE.createDynamicDataset();
        row.getQueries().addAll(asList(row0, row1));

        final ObjectElement columnId = TableFactory.eINSTANCE.createObjectElement();
        columnId.setHeader(
                TableFactory.eINSTANCE.createFixedCellDescriptor(Messages.hcf_table_hcf_id_label));
        final PropertyCellDescriptor columnIdCell = TableFactory.eINSTANCE
                .createPropertyCellDescriptor();
        columnIdCell.setOrigin(row.getQueries().indexOf(row0));
        applyFeaturePath(columnIdCell, EFeaturePath.build(IDENTIFIED_ELEMENT__ID));
        columnId.setCell(columnIdCell);

        final ObjectElement columnHcf = TableFactory.eINSTANCE.createObjectElement();
        columnHcf.setHeader(
                TableFactory.eINSTANCE.createFixedCellDescriptor(Messages.hcf_table_hcf_label));
        final PropertyCellDescriptor columnHcfCell = TableFactory.eINSTANCE
                .createPropertyCellDescriptor();
        columnHcfCell.setOrigin(row.getQueries().indexOf(row0));
        applyFeaturePath(columnHcfCell, EFeaturePath.build(IDENTIFIED_ELEMENT__DESCRIPTION));
        columnHcfCell.setLineWrap(true);
        columnHcf.setCell(columnHcfCell);

        final ObjectElement columnHintWord = TableFactory.eINSTANCE.createObjectElement();
        columnHintWord.setHeader(
                TableFactory.eINSTANCE
                        .createFixedCellDescriptor(Messages.hcf_table_hint_word_label));
        final PropertyCellDescriptor columnHintWordCell = TableFactory.eINSTANCE
                .createPropertyCellDescriptor();
        columnHintWordCell.setOrigin(row.getQueries().indexOf(row1));
        applyFeaturePath(columnHintWordCell, EFeaturePath.build(HCF_ANALYSIS_RESULT__HINT_WORD));
        columnHintWordCell.setLineWrap(true);
        columnHintWord.setCell(columnHintWordCell);

        final ObjectElement columnScenario = TableFactory.eINSTANCE.createObjectElement();
        columnScenario.setHeader(
                TableFactory.eINSTANCE
                        .createFixedCellDescriptor(Messages.hcf_table_hazard_scenario_label));
        final NativeCellDescriptor columnScenarioCell = TableFactory.eINSTANCE
                .createNativeCellDescriptor();
        columnScenarioCell.setImplementationClass(HCFScenarioCellEvaluator.class);
        columnScenario.setCell(columnScenarioCell);

        final ElementSet columnSet = TableFactory.eINSTANCE.createElementSet();
        columnSet.getElements().addAll(
                asList(columnId, columnHcf, columnHintWord, columnScenario));
        final FixedDataset column = TableFactory.eINSTANCE.createFixedDataset();
        column.getElementSets().add(columnSet);

        final Table table = TableFactory.eINSTANCE.createTable();
        table.getColumns().add(column);
        table.getRows().add(row);

        return table;
    }

    @Override
    protected JTable createJTable(final AdapterFactory adapterFactory, final Grid grid) {
        final GenericTableColumnProvider columnProvider = new HCFTableColumnProvider();
        final PropertyEditorFactory.Registry registry = new PropertyEditorFactoryRegistryImpl(
                Registry.INSTANCE);

        // コンポーネントを対象としたセルエディタ（のファクトリ）を作成
        final PropertyEditorFactory factory = new SingleEReferenceCellEditor.DescriptorImpl() {
            @Override
            protected Notifier resolveScope(final Object object) {
                final HCFTable hcfTable = (HCFTable) getDiagram();
                final ControlLoop controlLoop = hcfTable.getControlLoop();
                return controlLoop.getHintWordSet();
            }
        };

        registry.getFeatureMap().put(STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HINT_WORD, factory);

        columnProvider.setAdapterFactory(adapterFactory);
        columnProvider.setGrid(grid);

        final TransactionalEditingDomain txDomain = TransactionUtil.getEditingDomain(getDiagram());
        return JTableBuilder.builder(txDomain).adapterFactory(adapterFactory)
                .columnProvider(columnProvider)
                .transferHandler(new GenericTableTableTransferHandler(txDomain, domain)).input(grid)
                .propertyEditorFactoryRegistry(registry)
                .font(resolveTableFont())
                .reorderingAllowed(false)
                .build(new GenericTable());
    }

    private STPAAnalysis getSTPAAnalysis() {
        final HCFTable hcfTable = (HCFTable) getDiagram();
        final ControlLoop controlLoop = hcfTable.getControlLoop();
        return controlLoop.getHintWordSet().getOwner();
    }

    @Override
    protected AdapterFactory createTableAdapterFactory() {
        final EditingDomain domain = TransactionUtil.getEditingDomain(getDiagram());
        final STPAAnalysis stpaAnalysis = getSTPAAnalysis();
        final HCFAnalysis hcfAnalysis = stpaAnalysis.getHcfAnalysis();
        final UnsafeControlAction uca = ((HCFTable) getDiagram()).getUnsafeControlAction();
        return new GenericTableAdapterFactory(ItemProviders.getAdapterFactory(domain)) {

            @Override
            protected IItemProviderDecorator createGridDecorator() {
                return new GridItemProviderDecorator(this) {
                    @Override
                    protected Command createPrepareRowTupleCommand(final Grid grid,
                            final Tuple tuple,
                            final EditingDomain domain) {
                        return prepareHazardCausalFactorCommand(tuple);
                    }

                    @Override
                    protected Command createMoveRowElementCommand(final EObject owner,
                            final Tuple tuple,
                            final int index,
                            final EditingDomain defaultDomain) {
                        return createMoveHcfCommand(owner, tuple, index, domain);
                    }
                };
            }

            protected Command createMoveHcfCommand(final EObject owner,
                    final Tuple tuple,
                    final int index,
                    final EditingDomain defaultDomain) {
                final Tuple targetTuple = grid.getRowTuples().get(index);
                final HazardCausalFactor target = (HazardCausalFactor) targetTuple
                        .getElementObject(0);
                final STPAAnalysis targetOwner = target.getOwner();
                final int targetIndex = targetOwner.getHazardCausalFactors().indexOf(target);

                final EObject value = tuple.getElementObject(0);
                return MoveCommand.create(getEditingDomainFor(targetOwner), targetOwner,
                        STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR, value, targetIndex);
            }

            protected Command prepareHazardCausalFactorCommand(final Tuple rowTuple) {
                final HazardCausalFactor hcf = STAMPFactory.eINSTANCE.createHazardCausalFactor();
                final HCFAnalysisResult result = STAMPFactory.eINSTANCE.createHCFAnalysisResult();
                final EList<Element> elements = rowTuple.getElements();
                elements.get(HAZARD_CAUSAL_FACTOR__INDEX).setObject(hcf);

                final EditingDomain domain = getEditingDomainFor(stpaAnalysis);
                final CompoundCommand command = new CompoundCommand();
                final CommandParameter hcfDescription = new CommandParameter(stpaAnalysis,
                        STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR, hcf);
                hcf.setUnsafeControlAction(uca);
                command.append(CreateChildCommand.create(domain, stpaAnalysis, hcfDescription,
                        singleton(stpaAnalysis)));
                // HCFの追加時にHCFAnalysisResultも追加する
                result.setUnsafeControlAction(uca);
                result.getHazardCausalFactors().add(hcf);
                final CommandParameter resultDescriptor = new CommandParameter(hcfAnalysis,
                        HCF_ANALYSIS__RESULT, result);
                command.append(CreateChildCommand.create(domain, hcfAnalysis, resultDescriptor,
                        singleton(hcfAnalysis)));
                return command;
            }
        };
    }

    @Override
    protected Container createNorthPanel() {
        final Container panel = super.createNorthPanel();
        panel.add(createUcaInfoPanel(), 0);
        updateUcaInfo();
        return panel;
    }

    private Container createUcaInfoPanel() {
        final JPanel infoPanel = new JPanel();
        infoPanel.setLayout(new BoxLayout(infoPanel, BoxLayout.Y_AXIS));
        infoPanel.setBorder(
                new CompoundBorder(infoPanel.getBorder(), new EmptyBorder(10, 10, 0, 0)));

        // UCAの情報
        final JPanel ucaPanel = new JPanel();
        ucaPanel.setLayout(new BorderLayout(10, 0));

        ucaId = new JLabel();
        ucaDescription = new JTextArea();

        ucaDescription.setEditable(false);
        ucaDescription.setBackground(ucaPanel.getBackground());
        ucaDescription.setLineWrap(true);

        ucaPanel.add(BorderLayout.WEST, ucaId);
        ucaPanel.add(BorderLayout.CENTER, ucaDescription);

        // ヒントワードセットの情報
        final JPanel hwsPanel = new JPanel();
        hwsPanel.setLayout(new BoxLayout(hwsPanel, BoxLayout.X_AXIS));

        hwsPanel.add(new JLabel(Messages.hcf_table_info_hint_word_set_label));
        hwsPanel.add(Box.createHorizontalStrut(10));
        hwsComboBox = createHintWordSetComboBox();
        hwsPanel.add(hwsComboBox);
        hwsPanel.add(Box.createHorizontalStrut(10));
        hwsButton = new JButton(Messages.hcf_table_button_hint_word_label);
        hwsButton.addActionListener(this);
        hwsPanel.add(hwsButton);
        hwsPanel.add(Box.createHorizontalGlue());

        infoPanel.add(ucaPanel);
        infoPanel.add(Box.createVerticalStrut(10));
        infoPanel.add(hwsPanel);

        return infoPanel;
    }

    private JComboBox<HCFHintWordSet> createHintWordSetComboBox() {
        final STPAAnalysis stpaAnalysis = getSTPAAnalysis();
        final EList<HCFHintWordSet> hintWordSets = HCFHintWordSets
                .getLanguageHintWordSets(stpaAnalysis, domain.getResourceSet());

        final DefaultComboBoxModel<HCFHintWordSet> cmbModel = new DefaultComboBoxModel<>(
                hintWordSets.toArray(new HCFHintWordSet[] {}));
        final JComboBox<HCFHintWordSet> hwsComboBox = new JComboBox<HCFHintWordSet>(cmbModel);
        hwsComboBox.addPropertyChangeListener("ancestor", new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent evt) {
                if (evt.getNewValue() == null) {
                    ((LabelProviderListCellRenderer) hwsComboBox.getRenderer()).dispose();
                }
            }
        });

        final HCFTable hcfTable = (HCFTable) getDiagram();
        final ControlLoop controlLoop = hcfTable.getControlLoop();
        final HCFHintWordSet hintWordSet = controlLoop.getHintWordSet();
        if (hintWordSet != null) {
            hwsComboBox.setSelectedItem(hintWordSet);
        }

        final LabelProviderListCellRenderer renderer = new LabelProviderListCellRenderer(
                new AdapterFactoryVariantLabelProvider(
                        ItemProviders.getAdapterFactory(stpaAnalysis),
                        ExtraLabelVariant.MODEL_LIST));
        hwsComboBox.setRenderer(renderer);
        hwsComboBox.setEditable(false);

        final Dimension preferredSize = hwsComboBox.getPreferredSize();
        preferredSize.width += 5;
        hwsComboBox.setPreferredSize(preferredSize);
        hwsComboBox.setMaximumSize(preferredSize);
        hwsComboBox.setMinimumSize(new Dimension(150, preferredSize.height));

        hwsComboBox.addActionListener(this);

        return hwsComboBox;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void actionPerformed(final ActionEvent e) {
        if (e.getSource() == hwsComboBox) {
            SwingInvoker.runLaterInEDT(() -> {
                changeHintWordSet();
            });
        } else if (e.getSource() == hwsButton) {
            toggleHintWordImage();
        }
    }

    private void changeHintWordSet() {
        final HCFTable hcfTable = (HCFTable) getDiagram();
        final ControlLoop controlLoop = hcfTable.getControlLoop();
        final HCFHintWordSet selectionHWS = (HCFHintWordSet) hwsComboBox.getSelectedItem();
        final HCFHintWordSet selectedHWS = controlLoop.getHintWordSet();
        if (Objects.equal(selectionHWS.getName(), selectedHWS.getName())
                && Objects.equal(selectionHWS.getLanguage(), selectedHWS.getLanguage())) {
            updateHintWordSetFrame();
            return;
        }

        stopEditing();

        final STPAAnalysis stpaAnalysis = getSTPAAnalysis();
        final HCFAnalysis hcfAnalysis = stpaAnalysis.getHcfAnalysis();
        if (hcfAnalysis.getResults().stream().anyMatch(result -> {
            return result.eIsSet(HCF_ANALYSIS_RESULT__HINT_WORD)
                    && isClearHintWord(controlLoop, result);
        })) {
            final int yesno = MessageManager.displayYesNoDialog("",
                    Messages.hcf_table_ask_change_hint_word_set_label);
            if (yesno != MessageManager.YES) {
                hwsComboBox.setSelectedItem(selectedHWS);
                hwsComboBox.updateUI();
                return;
            }
        }

        final TransactionalEditingDomain txDomain = TransactionUtil.getEditingDomain(hcfTable);
        final CompoundCommand command = new CompoundCommand();
        final HCFHintWordSet newSelectionHWS;
        // ヒントワードセットがプロジェクトに存在しない場合には、取り込む
        if (!HCFHintWordSets.isHCFHintWordSetPresent(selectionHWS, stpaAnalysis)) {
            final EcoreCopier copier = new EcoreCopier();
            final EObject copyObject = copier.copy(selectionHWS);
            command.append(AddCommand.create(domain, stpaAnalysis,
                    STAMPPackage.Literals.HCF_HINT_WORD_SET, copyObject));
            newSelectionHWS = (HCFHintWordSet) copyObject;
            hwsComboBox.insertItemAt(newSelectionHWS, stpaAnalysis.getHCFHintWordSets().size());
        } else {
            newSelectionHWS = HCFHintWordSets.getHintWordSetInProject(selectionHWS, stpaAnalysis);
        }

        hcfAnalysis.getResults().forEach(result -> {
            if (isClearHintWord(controlLoop, result)) {
                command.append(SetCommand.create(txDomain, result, HCF_ANALYSIS_RESULT__HINT_WORD,
                        SetCommand.UNSET_VALUE));
            }
        });
        command.append(
                SetCommand.create(txDomain, controlLoop, CONTROL_LOOP__HINT_WORD_SET,
                        newSelectionHWS));
        hwsComboBox.updateUI();

        final CommandJob job = new CommandJob(txDomain, command.unwrap());
        Jobs.toCompletableFuture(job, true).thenRun(this::updateHintWordSetFrame);
        job.schedule();
    }

    private boolean isClearHintWord(final ControlLoop controlLoop, final HCFAnalysisResult result) {
        // ヒントワードセットを変更した時にクリアするヒントワードを
        // 対象のControlLoopが参照しているものだけに限定する
        return controlLoop.getTargetLink().getActions()
                .contains(result.getUnsafeControlAction().getControlAction());
    }

    private void toggleHintWordImage() {
        final OpenHintWordImageCommand cmd = new OpenHintWordImageCommand();
        final CommandEvent event = new CommandEvent(this, 0, "", cmd, 0,
                CommandEvent.RUN_TYPE_THREAD_SAME);
        CommandManager.instance().commandPerformed(event);
    }

    @Override
    public void tableEditorActivated(final Editor previousEditor) {
        super.tableEditorActivated(previousEditor);
        if (previousEditor != null && previousEditor.getEditorPeer() == this) {
            return;
        }

        if (hwsComboBox != null) {
            final STPAAnalysis analysis = getSTPAAnalysis();
            final EList<HCFHintWordSet> hintWordSets = HCFHintWordSets
                    .getLanguageHintWordSets(analysis, analysis.eResource().getResourceSet());
            final HCFTable hcfTable = (HCFTable) getDiagram();
            HCFHintWordSet selectedHWS = hcfTable.getControlLoop().getHintWordSet();
            final boolean thisIsLintening = Arrays.asList(hwsComboBox.getActionListeners())
                    .contains(this);
            hwsComboBox.removeActionListener(this);
            hwsComboBox.removeAllItems();
            for (int i = 0; i < hintWordSets.size(); i++) {
                hwsComboBox.insertItemAt(hintWordSets.get(i), i);
            }
            hwsComboBox.setSelectedItem(selectedHWS);
            if (thisIsLintening) {
                hwsComboBox.addActionListener(this);
            }
        }

        updateHintWordSetFrame();
    }

    private void updateHintWordSetFrame() {
        final HCFTable hcfTable = (HCFTable) getDiagram();
        if (AdapterFactoryEditingDomain.getEditingDomainFor(hcfTable) == null) {
            return;
        }

        final HCFHintWordSetFrame frame = (HCFHintWordSetFrame) DiagramEditor.getPaletteframe();
        if (frame == null) {
            return;
        }

        final ControlLoop controlLoop = hcfTable.getControlLoop();
        frame.updateComboBox(controlLoop);
        try {
            frame.update();
        } catch (final IOException e) {
            LOGGER.error("Update HCFHintWordSetFrame failed.", e);
        }
    }

    /**
     * 指定のUCAに紐づくHCFを取得した結果を返す {@link net.astah.table.IQueryExecutor.Provider}
     */
    public static class HazardCausalFactorFactory implements IQueryExecutor.Provider {
        @Override
        public IQueryExecutor createExecutor(final DataQuery dataQuery) {
            return new IQueryExecutor() {
                @Override
                public Iterator<? extends EObject> executeQuery(
                        final EMap<DataQuery, EObject> dependencies) {
                    final EAnnotation annotation = dataQuery.getEAnnotation(ANNOTATION__HCF_TABLE);
                    final HCFTable table = (HCFTable) annotation.getReferences().get(0);
                    final UnsafeControlAction uca = table.getUnsafeControlAction();
                    final EFeaturePath path = EFeaturePath
                            .build(HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION);
                    return path.getInverseReferences(uca).stream()
                            .sorted(EComparators.eObjectPath()).iterator();
                }
            };
        }

        @Override
        public Command createDeleteElementObjectCommand(final EditingDomain domain,
                final DataQuery dataQuery, final Tuple tuple) {
            final int index = dataQuery.getIndexOfDataset();
            if (index == HAZARD_CAUSAL_FACTOR__INDEX) {
                final EObject element = tuple.getElementObject(index);
                if (element != null) {
                    final EditingDomain editingDomain = getEditingDomainFor(element);
                    final CompoundCommand command = new CompoundCommand();
                    // 削除だけでは、ReferenceIndexSequencerに指定した参照パスに変化がないためIDが再採番されない
                    // 削除前に参照をクリアすることで、参照パスに変更を発生させている
                    command.append(SetCommand.create(editingDomain, element,
                            HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION, SetCommand.UNSET_VALUE));
                    command.append(
                            DestroyCommand.create(editingDomain, Collections.singleton(element)));
                    return command.unwrap();
                }
            }
            return UnexecutableCommand.INSTANCE;
        }
    }

    @Override
    protected JButton createExportButton() {
        return new ExportExcelButton() {
            private static final long serialVersionUID = 1L;

            @Override
            protected void exportFile(JTable table, String path) {
                final HCFTable hcfTable = (HCFTable) getDiagram();
                final UnsafeControlAction uca = hcfTable.getUnsafeControlAction();
                table.setName(uca.getId());
                new TableExcelExport(table).export(path);
            }
        };
    }

}
