/**
 */
package net.astah.stpa.stamp;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hazard Causal Factor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.HazardCausalFactor#getOwner <em>Owner</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.HazardCausalFactor#getHazardScenarios <em>Hazard Scenario</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.HazardCausalFactor#getUnsafeControlAction <em>Unsafe Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.HazardCausalFactor#getCountermeasures <em>Countermeasure</em>}</li>
 * </ul>
 *
 * @see net.astah.stpa.stamp.STAMPPackage#getHazardCausalFactor()
 * @model
 * @generated
 */
public interface HazardCausalFactor extends IdentifiedElement {
    /**
     * Returns the value of the '<em><b>Unsafe Control Action</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Unsafe Control Action</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Unsafe Control Action</em>' reference.
     * @see #setUnsafeControlAction(UnsafeControlAction)
     * @see net.astah.stpa.stamp.STAMPPackage#getHazardCausalFactor_UnsafeControlAction()
     * @model required="true" ordered="false"
     * @generated
     */
    UnsafeControlAction getUnsafeControlAction();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.HazardCausalFactor#getUnsafeControlAction <em>Unsafe Control Action</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Unsafe Control Action</em>' reference.
     * @see #getUnsafeControlAction()
     * @generated
     */
    void setUnsafeControlAction(UnsafeControlAction value);

    /**
     * Returns the value of the '<em><b>Countermeasure</b></em>' reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Countermeasure}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Countermeasure#getHazardCausalFactors <em>Hazard Causal Factor</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Countermeasure</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Countermeasure</em>' reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getHazardCausalFactor_Countermeasure()
     * @see net.astah.stpa.stamp.Countermeasure#getHazardCausalFactors
     * @model opposite="hazardCausalFactor"
     * @generated
     */
    EList<Countermeasure> getCountermeasures();

    /**
     * Returns the value of the '<em><b>Owner</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.STPAAnalysis#getHazardCausalFactors <em>Hazard Causal Factor</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Owner</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Owner</em>' container reference.
     * @see #setOwner(STPAAnalysis)
     * @see net.astah.stpa.stamp.STAMPPackage#getHazardCausalFactor_Owner()
     * @see net.astah.stpa.stamp.STPAAnalysis#getHazardCausalFactors
     * @model opposite="hazardCausalFactor" required="true" transient="false" ordered="false"
     * @generated
     */
    STPAAnalysis getOwner();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.HazardCausalFactor#getOwner <em>Owner</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Owner</em>' container reference.
     * @see #getOwner()
     * @generated
     */
    void setOwner(STPAAnalysis value);

    /**
     * Returns the value of the '<em><b>Hazard Scenario</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.HazardScenario}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Hazard Scenario</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hazard Scenario</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getHazardCausalFactor_HazardScenario()
     * @model containment="true" resolveProxies="true"
     * @generated
     */
    EList<HazardScenario> getHazardScenarios();

    /**
     * Creates a new {@link net.astah.stpa.stamp.HazardScenario} and appends it to the '<em><b>Hazard Scenario</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.HazardScenario}.
     * @see #getHazardScenarios()
     * @generated
     */
    HazardScenario createHazardScenario();

} // HazardCausalFactor
