/**
 */
package net.astah.stpa.stamp.util;

import net.astah.stpa.stamp.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see net.astah.stpa.stamp.STAMPPackage
 * @generated
 */
public class STAMPAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static STAMPPackage modelPackage;

    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = STAMPPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch that delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected STAMPSwitch<Adapter> modelSwitch =
        new STAMPSwitch<Adapter>() {
            @Override
            public Adapter caseSTPAAnalysis(STPAAnalysis object) {
                return createSTPAAnalysisAdapter();
            }
            @Override
            public Adapter caseNamedElement(NamedElement object) {
                return createNamedElementAdapter();
            }
            @Override
            public Adapter caseElement(Element object) {
                return createElementAdapter();
            }
            @Override
            public Adapter caseNote(Note object) {
                return createNoteAdapter();
            }
            @Override
            public Adapter caseNoteAnchor(NoteAnchor object) {
                return createNoteAnchorAdapter();
            }
            @Override
            public Adapter caseAccident(Accident object) {
                return createAccidentAdapter();
            }
            @Override
            public Adapter caseIdentifiedElement(IdentifiedElement object) {
                return createIdentifiedElementAdapter();
            }
            @Override
            public Adapter caseHazard(Hazard object) {
                return createHazardAdapter();
            }
            @Override
            public Adapter caseSafetyConstraint(SafetyConstraint object) {
                return createSafetyConstraintAdapter();
            }
            @Override
            public Adapter casePrecondition(Precondition object) {
                return createPreconditionAdapter();
            }
            @Override
            public Adapter caseControlStructure(ControlStructure object) {
                return createControlStructureAdapter();
            }
            @Override
            public Adapter caseComponent(Component object) {
                return createComponentAdapter();
            }
            @Override
            public Adapter caseLinkableElement(LinkableElement object) {
                return createLinkableElementAdapter();
            }
            @Override
            public Adapter caseProcessModel(ProcessModel object) {
                return createProcessModelAdapter();
            }
            @Override
            public Adapter caseProcessVariable(ProcessVariable object) {
                return createProcessVariableAdapter();
            }
            @Override
            public Adapter caseProcessValue(ProcessValue object) {
                return createProcessValueAdapter();
            }
            @Override
            public Adapter caseLink(Link object) {
                return createLinkAdapter();
            }
            @Override
            public Adapter caseSignal(Signal object) {
                return createSignalAdapter();
            }
            @Override
            public Adapter caseLinkEnd(LinkEnd object) {
                return createLinkEndAdapter();
            }
            @Override
            public Adapter caseCountermeasure(Countermeasure object) {
                return createCountermeasureAdapter();
            }
            @Override
            public Adapter caseHazardCausalFactor(HazardCausalFactor object) {
                return createHazardCausalFactorAdapter();
            }
            @Override
            public Adapter caseHazardScenario(HazardScenario object) {
                return createHazardScenarioAdapter();
            }
            @Override
            public Adapter caseUnsafeControlAction(UnsafeControlAction object) {
                return createUnsafeControlActionAdapter();
            }
            @Override
            public Adapter caseControlAction(ControlAction object) {
                return createControlActionAdapter();
            }
            @Override
            public Adapter caseControlLink(ControlLink object) {
                return createControlLinkAdapter();
            }
            @Override
            public Adapter caseUCAGuideWordSet(UCAGuideWordSet object) {
                return createUCAGuideWordSetAdapter();
            }
            @Override
            public Adapter caseUCAGuideWord(UCAGuideWord object) {
                return createUCAGuideWordAdapter();
            }
            @Override
            public Adapter caseHCFHintWordSet(HCFHintWordSet object) {
                return createHCFHintWordSetAdapter();
            }
            @Override
            public Adapter caseHCFHintWord(HCFHintWord object) {
                return createHCFHintWordAdapter();
            }
            @Override
            public Adapter caseUCAAnalysis(UCAAnalysis object) {
                return createUCAAnalysisAdapter();
            }
            @Override
            public Adapter caseUCAAnalysisResult(UCAAnalysisResult object) {
                return createUCAAnalysisResultAdapter();
            }
            @Override
            public Adapter caseHCFAnalysis(HCFAnalysis object) {
                return createHCFAnalysisAdapter();
            }
            @Override
            public Adapter caseHCFAnalysisResult(HCFAnalysisResult object) {
                return createHCFAnalysisResultAdapter();
            }
            @Override
            public Adapter caseControlLoop(ControlLoop object) {
                return createControlLoopAdapter();
            }
            @Override
            public Adapter caseFeedbackLink(FeedbackLink object) {
                return createFeedbackLinkAdapter();
            }
            @Override
            public Adapter caseFeedback(Feedback object) {
                return createFeedbackAdapter();
            }
            @Override
            public Adapter caseEModelElement(EModelElement object) {
                return createEModelElementAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object) {
                return createEObjectAdapter();
            }
        };

    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target) {
        return modelSwitch.doSwitch((EObject)target);
    }


    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Component <em>Component</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Component
     * @generated
     */
    public Adapter createComponentAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.LinkableElement <em>Linkable Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.LinkableElement
     * @generated
     */
    public Adapter createLinkableElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.NamedElement <em>Named Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.NamedElement
     * @generated
     */
    public Adapter createNamedElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Element <em>Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Element
     * @generated
     */
    public Adapter createElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Note <em>Note</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Note
     * @generated
     */
    public Adapter createNoteAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ControlStructure <em>Control Structure</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ControlStructure
     * @generated
     */
    public Adapter createControlStructureAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Link <em>Link</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Link
     * @generated
     */
    public Adapter createLinkAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Signal <em>Signal</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Signal
     * @generated
     */
    public Adapter createSignalAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ControlAction <em>Control Action</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ControlAction
     * @generated
     */
    public Adapter createControlActionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.UCAAnalysisResult <em>UCA Analysis Result</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.UCAAnalysisResult
     * @generated
     */
    public Adapter createUCAAnalysisResultAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.UnsafeControlAction <em>Unsafe Control Action</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.UnsafeControlAction
     * @generated
     */
    public Adapter createUnsafeControlActionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.IdentifiedElement <em>Identified Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.IdentifiedElement
     * @generated
     */
    public Adapter createIdentifiedElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.STPAAnalysis <em>STPA Analysis</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.STPAAnalysis
     * @generated
     */
    public Adapter createSTPAAnalysisAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ProcessModel <em>Process Model</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ProcessModel
     * @generated
     */
    public Adapter createProcessModelAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ProcessVariable <em>Process Variable</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ProcessVariable
     * @generated
     */
    public Adapter createProcessVariableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ProcessValue <em>Process Value</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ProcessValue
     * @generated
     */
    public Adapter createProcessValueAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ControlLink <em>Control Link</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ControlLink
     * @generated
     */
    public Adapter createControlLinkAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Accident <em>Accident</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Accident
     * @generated
     */
    public Adapter createAccidentAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Hazard <em>Hazard</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Hazard
     * @generated
     */
    public Adapter createHazardAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.SafetyConstraint <em>Safety Constraint</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.SafetyConstraint
     * @generated
     */
    public Adapter createSafetyConstraintAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Precondition <em>Precondition</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Precondition
     * @generated
     */
    public Adapter createPreconditionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Countermeasure <em>Countermeasure</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Countermeasure
     * @generated
     */
    public Adapter createCountermeasureAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.UCAGuideWordSet <em>UCA Guide Word Set</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.UCAGuideWordSet
     * @generated
     */
    public Adapter createUCAGuideWordSetAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.HCFHintWordSet <em>HCF Hint Word Set</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.HCFHintWordSet
     * @generated
     */
    public Adapter createHCFHintWordSetAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.UCAAnalysis <em>UCA Analysis</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.UCAAnalysis
     * @generated
     */
    public Adapter createUCAAnalysisAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.LinkEnd <em>Link End</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.LinkEnd
     * @generated
     */
    public Adapter createLinkEndAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.UCAGuideWord <em>UCA Guide Word</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.UCAGuideWord
     * @generated
     */
    public Adapter createUCAGuideWordAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.HCFAnalysis <em>HCF Analysis</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.HCFAnalysis
     * @generated
     */
    public Adapter createHCFAnalysisAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.HCFAnalysisResult <em>HCF Analysis Result</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.HCFAnalysisResult
     * @generated
     */
    public Adapter createHCFAnalysisResultAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.HazardCausalFactor <em>Hazard Causal Factor</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.HazardCausalFactor
     * @generated
     */
    public Adapter createHazardCausalFactorAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.HazardScenario <em>Hazard Scenario</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.HazardScenario
     * @generated
     */
    public Adapter createHazardScenarioAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.HCFHintWord <em>HCF Hint Word</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.HCFHintWord
     * @generated
     */
    public Adapter createHCFHintWordAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.ControlLoop <em>Control Loop</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.ControlLoop
     * @generated
     */
    public Adapter createControlLoopAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.Feedback <em>Feedback</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.Feedback
     * @generated
     */
    public Adapter createFeedbackAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.FeedbackLink <em>Feedback Link</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.FeedbackLink
     * @generated
     */
    public Adapter createFeedbackLinkAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.NoteAnchor <em>Note Anchor</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.NoteAnchor
     * @generated
     */
    public Adapter createNoteAnchorAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.eclipse.emf.ecore.EModelElement <em>EModel Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.eclipse.emf.ecore.EModelElement
     * @generated
     */
    public Adapter createEModelElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} //STAMPAdapterFactory
