/**
 */
package net.astah.stpa.stamp.util;

import net.astah.stpa.stamp.*;

import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see net.astah.stpa.stamp.STAMPPackage
 * @generated
 */
public class STAMPSwitch<T> extends Switch<T> {
    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static STAMPPackage modelPackage;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPSwitch() {
        if (modelPackage == null) {
            modelPackage = STAMPPackage.eINSTANCE;
        }
    }

    /**
     * Checks whether this is a switch for the given package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param ePackage the package in question.
     * @return whether this is a switch for the given package.
     * @generated
     */
    @Override
    protected boolean isSwitchFor(EPackage ePackage) {
        return ePackage == modelPackage;
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    @Override
    protected T doSwitch(int classifierID, EObject theEObject) {
        switch (classifierID) {
            case STAMPPackage.STPA_ANALYSIS: {
                STPAAnalysis stpaAnalysis = (STPAAnalysis)theEObject;
                T result = caseSTPAAnalysis(stpaAnalysis);
                if (result == null) result = caseNamedElement(stpaAnalysis);
                if (result == null) result = caseElement(stpaAnalysis);
                if (result == null) result = caseEModelElement(stpaAnalysis);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.NAMED_ELEMENT: {
                NamedElement namedElement = (NamedElement)theEObject;
                T result = caseNamedElement(namedElement);
                if (result == null) result = caseElement(namedElement);
                if (result == null) result = caseEModelElement(namedElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.ELEMENT: {
                Element element = (Element)theEObject;
                T result = caseElement(element);
                if (result == null) result = caseEModelElement(element);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.NOTE: {
                Note note = (Note)theEObject;
                T result = caseNote(note);
                if (result == null) result = caseElement(note);
                if (result == null) result = caseEModelElement(note);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.NOTE_ANCHOR: {
                NoteAnchor noteAnchor = (NoteAnchor)theEObject;
                T result = caseNoteAnchor(noteAnchor);
                if (result == null) result = caseElement(noteAnchor);
                if (result == null) result = caseEModelElement(noteAnchor);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.ACCIDENT: {
                Accident accident = (Accident)theEObject;
                T result = caseAccident(accident);
                if (result == null) result = caseIdentifiedElement(accident);
                if (result == null) result = caseElement(accident);
                if (result == null) result = caseEModelElement(accident);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.IDENTIFIED_ELEMENT: {
                IdentifiedElement identifiedElement = (IdentifiedElement)theEObject;
                T result = caseIdentifiedElement(identifiedElement);
                if (result == null) result = caseElement(identifiedElement);
                if (result == null) result = caseEModelElement(identifiedElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HAZARD: {
                Hazard hazard = (Hazard)theEObject;
                T result = caseHazard(hazard);
                if (result == null) result = caseIdentifiedElement(hazard);
                if (result == null) result = caseElement(hazard);
                if (result == null) result = caseEModelElement(hazard);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.SAFETY_CONSTRAINT: {
                SafetyConstraint safetyConstraint = (SafetyConstraint)theEObject;
                T result = caseSafetyConstraint(safetyConstraint);
                if (result == null) result = caseIdentifiedElement(safetyConstraint);
                if (result == null) result = caseElement(safetyConstraint);
                if (result == null) result = caseEModelElement(safetyConstraint);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.PRECONDITION: {
                Precondition precondition = (Precondition)theEObject;
                T result = casePrecondition(precondition);
                if (result == null) result = caseIdentifiedElement(precondition);
                if (result == null) result = caseElement(precondition);
                if (result == null) result = caseEModelElement(precondition);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.CONTROL_STRUCTURE: {
                ControlStructure controlStructure = (ControlStructure)theEObject;
                T result = caseControlStructure(controlStructure);
                if (result == null) result = caseNamedElement(controlStructure);
                if (result == null) result = caseElement(controlStructure);
                if (result == null) result = caseEModelElement(controlStructure);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.COMPONENT: {
                Component component = (Component)theEObject;
                T result = caseComponent(component);
                if (result == null) result = caseLinkableElement(component);
                if (result == null) result = caseNamedElement(component);
                if (result == null) result = caseElement(component);
                if (result == null) result = caseEModelElement(component);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.LINKABLE_ELEMENT: {
                LinkableElement linkableElement = (LinkableElement)theEObject;
                T result = caseLinkableElement(linkableElement);
                if (result == null) result = caseNamedElement(linkableElement);
                if (result == null) result = caseElement(linkableElement);
                if (result == null) result = caseEModelElement(linkableElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.PROCESS_MODEL: {
                ProcessModel processModel = (ProcessModel)theEObject;
                T result = caseProcessModel(processModel);
                if (result == null) result = caseNamedElement(processModel);
                if (result == null) result = caseElement(processModel);
                if (result == null) result = caseEModelElement(processModel);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.PROCESS_VARIABLE: {
                ProcessVariable processVariable = (ProcessVariable)theEObject;
                T result = caseProcessVariable(processVariable);
                if (result == null) result = caseNamedElement(processVariable);
                if (result == null) result = caseElement(processVariable);
                if (result == null) result = caseEModelElement(processVariable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.PROCESS_VALUE: {
                ProcessValue processValue = (ProcessValue)theEObject;
                T result = caseProcessValue(processValue);
                if (result == null) result = caseNamedElement(processValue);
                if (result == null) result = caseElement(processValue);
                if (result == null) result = caseEModelElement(processValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.LINK: {
                Link link = (Link)theEObject;
                T result = caseLink(link);
                if (result == null) result = caseElement(link);
                if (result == null) result = caseEModelElement(link);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.SIGNAL: {
                Signal signal = (Signal)theEObject;
                T result = caseSignal(signal);
                if (result == null) result = caseNamedElement(signal);
                if (result == null) result = caseElement(signal);
                if (result == null) result = caseEModelElement(signal);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.LINK_END: {
                LinkEnd linkEnd = (LinkEnd)theEObject;
                T result = caseLinkEnd(linkEnd);
                if (result == null) result = caseLinkableElement(linkEnd);
                if (result == null) result = caseNamedElement(linkEnd);
                if (result == null) result = caseElement(linkEnd);
                if (result == null) result = caseEModelElement(linkEnd);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.COUNTERMEASURE: {
                Countermeasure countermeasure = (Countermeasure)theEObject;
                T result = caseCountermeasure(countermeasure);
                if (result == null) result = caseIdentifiedElement(countermeasure);
                if (result == null) result = caseElement(countermeasure);
                if (result == null) result = caseEModelElement(countermeasure);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HAZARD_CAUSAL_FACTOR: {
                HazardCausalFactor hazardCausalFactor = (HazardCausalFactor)theEObject;
                T result = caseHazardCausalFactor(hazardCausalFactor);
                if (result == null) result = caseIdentifiedElement(hazardCausalFactor);
                if (result == null) result = caseElement(hazardCausalFactor);
                if (result == null) result = caseEModelElement(hazardCausalFactor);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HAZARD_SCENARIO: {
                HazardScenario hazardScenario = (HazardScenario)theEObject;
                T result = caseHazardScenario(hazardScenario);
                if (result == null) result = caseIdentifiedElement(hazardScenario);
                if (result == null) result = caseElement(hazardScenario);
                if (result == null) result = caseEModelElement(hazardScenario);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.UNSAFE_CONTROL_ACTION: {
                UnsafeControlAction unsafeControlAction = (UnsafeControlAction)theEObject;
                T result = caseUnsafeControlAction(unsafeControlAction);
                if (result == null) result = caseIdentifiedElement(unsafeControlAction);
                if (result == null) result = caseElement(unsafeControlAction);
                if (result == null) result = caseEModelElement(unsafeControlAction);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.CONTROL_ACTION: {
                ControlAction controlAction = (ControlAction)theEObject;
                T result = caseControlAction(controlAction);
                if (result == null) result = caseSignal(controlAction);
                if (result == null) result = caseNamedElement(controlAction);
                if (result == null) result = caseElement(controlAction);
                if (result == null) result = caseEModelElement(controlAction);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.CONTROL_LINK: {
                ControlLink controlLink = (ControlLink)theEObject;
                T result = caseControlLink(controlLink);
                if (result == null) result = caseLink(controlLink);
                if (result == null) result = caseElement(controlLink);
                if (result == null) result = caseEModelElement(controlLink);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.UCA_GUIDE_WORD_SET: {
                UCAGuideWordSet ucaGuideWordSet = (UCAGuideWordSet)theEObject;
                T result = caseUCAGuideWordSet(ucaGuideWordSet);
                if (result == null) result = caseNamedElement(ucaGuideWordSet);
                if (result == null) result = caseElement(ucaGuideWordSet);
                if (result == null) result = caseEModelElement(ucaGuideWordSet);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.UCA_GUIDE_WORD: {
                UCAGuideWord ucaGuideWord = (UCAGuideWord)theEObject;
                T result = caseUCAGuideWord(ucaGuideWord);
                if (result == null) result = caseNamedElement(ucaGuideWord);
                if (result == null) result = caseElement(ucaGuideWord);
                if (result == null) result = caseEModelElement(ucaGuideWord);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HCF_HINT_WORD_SET: {
                HCFHintWordSet hcfHintWordSet = (HCFHintWordSet)theEObject;
                T result = caseHCFHintWordSet(hcfHintWordSet);
                if (result == null) result = caseNamedElement(hcfHintWordSet);
                if (result == null) result = caseElement(hcfHintWordSet);
                if (result == null) result = caseEModelElement(hcfHintWordSet);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HCF_HINT_WORD: {
                HCFHintWord hcfHintWord = (HCFHintWord)theEObject;
                T result = caseHCFHintWord(hcfHintWord);
                if (result == null) result = caseNamedElement(hcfHintWord);
                if (result == null) result = caseElement(hcfHintWord);
                if (result == null) result = caseEModelElement(hcfHintWord);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.UCA_ANALYSIS: {
                UCAAnalysis ucaAnalysis = (UCAAnalysis)theEObject;
                T result = caseUCAAnalysis(ucaAnalysis);
                if (result == null) result = caseElement(ucaAnalysis);
                if (result == null) result = caseEModelElement(ucaAnalysis);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.UCA_ANALYSIS_RESULT: {
                UCAAnalysisResult ucaAnalysisResult = (UCAAnalysisResult)theEObject;
                T result = caseUCAAnalysisResult(ucaAnalysisResult);
                if (result == null) result = caseElement(ucaAnalysisResult);
                if (result == null) result = caseEModelElement(ucaAnalysisResult);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HCF_ANALYSIS: {
                HCFAnalysis hcfAnalysis = (HCFAnalysis)theEObject;
                T result = caseHCFAnalysis(hcfAnalysis);
                if (result == null) result = caseElement(hcfAnalysis);
                if (result == null) result = caseEModelElement(hcfAnalysis);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.HCF_ANALYSIS_RESULT: {
                HCFAnalysisResult hcfAnalysisResult = (HCFAnalysisResult)theEObject;
                T result = caseHCFAnalysisResult(hcfAnalysisResult);
                if (result == null) result = caseElement(hcfAnalysisResult);
                if (result == null) result = caseEModelElement(hcfAnalysisResult);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.CONTROL_LOOP: {
                ControlLoop controlLoop = (ControlLoop)theEObject;
                T result = caseControlLoop(controlLoop);
                if (result == null) result = caseNamedElement(controlLoop);
                if (result == null) result = caseElement(controlLoop);
                if (result == null) result = caseEModelElement(controlLoop);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.FEEDBACK_LINK: {
                FeedbackLink feedbackLink = (FeedbackLink)theEObject;
                T result = caseFeedbackLink(feedbackLink);
                if (result == null) result = caseLink(feedbackLink);
                if (result == null) result = caseElement(feedbackLink);
                if (result == null) result = caseEModelElement(feedbackLink);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPPackage.FEEDBACK: {
                Feedback feedback = (Feedback)theEObject;
                T result = caseFeedback(feedback);
                if (result == null) result = caseSignal(feedback);
                if (result == null) result = caseNamedElement(feedback);
                if (result == null) result = caseElement(feedback);
                if (result == null) result = caseEModelElement(feedback);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Component</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Component</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseComponent(Component object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Linkable Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Linkable Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseLinkableElement(LinkableElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Named Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Named Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNamedElement(NamedElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseElement(Element object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Note</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Note</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNote(Note object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Control Structure</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Control Structure</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseControlStructure(ControlStructure object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Link</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Link</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseLink(Link object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Signal</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Signal</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSignal(Signal object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Control Action</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Control Action</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseControlAction(ControlAction object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>UCA Analysis Result</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>UCA Analysis Result</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseUCAAnalysisResult(UCAAnalysisResult object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Unsafe Control Action</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Unsafe Control Action</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseUnsafeControlAction(UnsafeControlAction object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Identified Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Identified Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseIdentifiedElement(IdentifiedElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STPA Analysis</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STPA Analysis</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTPAAnalysis(STPAAnalysis object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Process Model</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Process Model</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseProcessModel(ProcessModel object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Process Variable</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Process Variable</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseProcessVariable(ProcessVariable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Process Value</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Process Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseProcessValue(ProcessValue object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Control Link</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Control Link</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseControlLink(ControlLink object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Accident</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Accident</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAccident(Accident object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Hazard</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Hazard</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHazard(Hazard object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Safety Constraint</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Safety Constraint</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSafetyConstraint(SafetyConstraint object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Precondition</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Precondition</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T casePrecondition(Precondition object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Countermeasure</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Countermeasure</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseCountermeasure(Countermeasure object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>UCA Guide Word Set</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>UCA Guide Word Set</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseUCAGuideWordSet(UCAGuideWordSet object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>HCF Hint Word Set</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>HCF Hint Word Set</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHCFHintWordSet(HCFHintWordSet object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>UCA Analysis</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>UCA Analysis</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseUCAAnalysis(UCAAnalysis object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Link End</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Link End</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseLinkEnd(LinkEnd object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>UCA Guide Word</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>UCA Guide Word</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseUCAGuideWord(UCAGuideWord object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>HCF Analysis</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>HCF Analysis</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHCFAnalysis(HCFAnalysis object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>HCF Analysis Result</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>HCF Analysis Result</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHCFAnalysisResult(HCFAnalysisResult object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Hazard Causal Factor</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Hazard Causal Factor</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHazardCausalFactor(HazardCausalFactor object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Hazard Scenario</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Hazard Scenario</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHazardScenario(HazardScenario object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>HCF Hint Word</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>HCF Hint Word</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHCFHintWord(HCFHintWord object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Control Loop</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Control Loop</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseControlLoop(ControlLoop object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Feedback</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Feedback</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseFeedback(Feedback object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Feedback Link</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Feedback Link</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseFeedbackLink(FeedbackLink object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Note Anchor</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Note Anchor</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNoteAnchor(NoteAnchor object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EModel Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EModel Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseEModelElement(EModelElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch, but this is the last case anyway.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    @Override
    public T defaultCase(EObject object) {
        return null;
    }

} //STAMPSwitch
